searchNodes=[{"doc":"A context for working with Pointers, a sort of global foreign key scheme.","ref":"Pointers.html","title":"Pointers","type":"module"},{"doc":"Return the provided pointer when it belongs to table queryable by the given table search term.","ref":"Pointers.html#assert_points_to!/2","title":"Pointers.assert_points_to!/2","type":"function"},{"doc":"Returns a Pointer, either the one provided or a synthesised one pointing to the provided schema object. Does not hit the database or cause the pointer to be written to the database whatsoever.","ref":"Pointers.html#cast!/1","title":"Pointers.cast!/1","type":"function"},{"doc":"Given a list of pointers which may or may have their pointed loaded, return a plan for preloading, a map of module name to set of loadable IDs.","ref":"Pointers.html#plan/1","title":"Pointers.plan/1","type":"function"},{"doc":"","ref":"Pointers.html#schema/1","title":"Pointers.schema/1","type":"function"},{"doc":"Looks up the table for a given pointer","ref":"Pointers.html#table/1","title":"Pointers.table/1","type":"function"},{"doc":"","ref":"Pointers.Changeset.html","title":"Pointers.Changeset","type":"module"},{"doc":"","ref":"Pointers.Changeset.html#insert_related/5","title":"Pointers.Changeset.insert_related/5","type":"function"},{"doc":"","ref":"Pointers.Changeset.html#relate/4","title":"Pointers.Changeset.relate/4","type":"function"},{"doc":"","ref":"Pointers.Changeset.html#valid?/1","title":"Pointers.Changeset.valid?/1","type":"function"},{"doc":"Helpers for writing Pointer-aware migrations.","ref":"Pointers.Migration.html","title":"Pointers.Migration","type":"module"},{"doc":"Adds a pointer primary key to the table. Not required if you are using create_pointable_table","ref":"Pointers.Migration.html#add_pointer_pk/0","title":"Pointers.Migration.add_pointer_pk/0","type":"function"},{"doc":"","ref":"Pointers.Migration.html#add_pointer_ref_pk/0","title":"Pointers.Migration.add_pointer_ref_pk/0","type":"function"},{"doc":"Creates a mixin table - one with a ULID primary key and no trigger","ref":"Pointers.Migration.html#create_mixin_table/3","title":"Pointers.Migration.create_mixin_table/3","type":"macro"},{"doc":"Creates a pointable table along with its trigger.","ref":"Pointers.Migration.html#create_pointable_table/2","title":"Pointers.Migration.create_pointable_table/2","type":"macro"},{"doc":"","ref":"Pointers.Migration.html#create_pointable_table/3","title":"Pointers.Migration.create_pointable_table/3","type":"macro"},{"doc":"","ref":"Pointers.Migration.html#create_pointable_table/4","title":"Pointers.Migration.create_pointable_table/4","type":"macro"},{"doc":"Drops a mixin table. Actually just a simple cascading drop","ref":"Pointers.Migration.html#drop_mixin_table/1","title":"Pointers.Migration.drop_mixin_table/1","type":"function"},{"doc":"Drops a pointable table","ref":"Pointers.Migration.html#drop_pointable_table/1","title":"Pointers.Migration.drop_pointable_table/1","type":"function"},{"doc":"","ref":"Pointers.Migration.html#drop_pointable_table/2","title":"Pointers.Migration.drop_pointable_table/2","type":"function"},{"doc":"","ref":"Pointers.Migration.html#drop_table/1","title":"Pointers.Migration.drop_table/1","type":"function"},{"doc":"When migrating up: initialises the pointers database. When migrating down: deinitialises the pointers database.","ref":"Pointers.Migration.html#init_pointers/0","title":"Pointers.Migration.init_pointers/0","type":"function"},{"doc":"Given :up: initialises the pointers database. Given :down: deinitialises the pointers database.","ref":"Pointers.Migration.html#init_pointers/1","title":"Pointers.Migration.init_pointers/1","type":"function"},{"doc":"See Pointers.ULID.Migration.init_pointers_ulid_extra/0.","ref":"Pointers.Migration.html#init_pointers_ulid_extra/0","title":"Pointers.Migration.init_pointers_ulid_extra/0","type":"function"},{"doc":"Creates a strong, weak or unbreakable pointer depending on type.","ref":"Pointers.Migration.html#pointer/2","title":"Pointers.Migration.pointer/2","type":"function"},{"doc":"A reference to a pointer for use with 'add/3`. A strong pointer will be deleted when the thing it's pointing to is deleted.","ref":"Pointers.Migration.html#strong_pointer/1","title":"Pointers.Migration.strong_pointer/1","type":"function"},{"doc":"A reference to a pointer for use with 'add/3`. An unbreakable pointer will prevent the thing it's pointing to from being deleted.","ref":"Pointers.Migration.html#unbreakable_pointer/1","title":"Pointers.Migration.unbreakable_pointer/1","type":"function"},{"doc":"A reference to a pointer for use with 'add/3`. A weak pointer will be set null when the thing it's pointing to is deleted.","ref":"Pointers.Migration.html#weak_pointer/1","title":"Pointers.Migration.weak_pointer/1","type":"function"},{"doc":"","ref":"Pointers.Migration.html#t:pointer_type/0","title":"Pointers.Migration.pointer_type/0","type":"type"},{"doc":"","ref":"Pointers.Mixin.html","title":"Pointers.Mixin","type":"module"},{"doc":"","ref":"Pointers.Mixin.html#mixin_schema/1","title":"Pointers.Mixin.mixin_schema/1","type":"macro"},{"doc":"","ref":"Pointers.Mixin.html#using/2","title":"Pointers.Mixin.using/2","type":"function"},{"doc":"Sets up an Ecto Schema for a Pointable table.Sample Usageuse Pointers.Pointable, otp_app: :my_app, # your OTP application&#39;s name source: &quot;my_table&quot;, # default name of table in database table_id: &quot;01EBTVSZJ6X02J01R1XWWPWGZW&quot; # valid ULID to identify table","ref":"Pointers.Pointable.html","title":"Pointers.Pointable","type":"module"},{"doc":"","ref":"Pointers.Pointable.html#pointable_schema/1","title":"Pointers.Pointable.pointable_schema/1","type":"macro"},{"doc":"A Pointer is a kind of global foreign key that can point to any of the tables participating in the abstraction.","ref":"Pointers.Pointer.html","title":"Pointers.Pointer","type":"module"},{"doc":"Changeset for creating a Pointer","ref":"Pointers.Pointer.html#create/2","title":"Pointers.Pointer.create/2","type":"function"},{"doc":"Changeset for updating which table a Pointer points to.","ref":"Pointers.Pointer.html#repoint/2","title":"Pointers.Pointer.repoint/2","type":"function"},{"doc":"One Table to rule them all. A record of a table participating in the pointers abstraction - mandatory if participating.","ref":"Pointers.Table.html","title":"Pointers.Table","type":"module"},{"doc":"","ref":"Pointers.Table.html#t:t/0","title":"Pointers.Table.t/0","type":"type"},{"doc":"A Global cache of Tables to be queried by their (Pointer) IDs, table names or Ecto Schema module names.Use of the Table Service requires:You have run the migrations shipped with this library.You have started Pointers.Tables before querying.All OTP applications with pointable Ecto Schemata to be added to the schema path.OTP 21.2 or greater, though we recommend using the most recent release available.While this module is a GenServer, it is only responsible for setup of the cache and then exits with :ignore having done so. It is not recommended to restart the service as this will lead to a stop the world garbage collection of all processes and the copying of the entire cache to each process that has queried it since its last local garbage collection.","ref":"Pointers.Tables.html","title":"Pointers.Tables","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Pointers.Tables.html#child_spec/1","title":"Pointers.Tables.child_spec/1","type":"function"},{"doc":"","ref":"Pointers.Tables.html#data/0","title":"Pointers.Tables.data/0","type":"function"},{"doc":"Look up a table id by id, name or schema.","ref":"Pointers.Tables.html#id/1","title":"Pointers.Tables.id/1","type":"function"},{"doc":"Look up a table id by id, name or schema, raise NotFound if not found.","ref":"Pointers.Tables.html#id!/1","title":"Pointers.Tables.id!/1","type":"function"},{"doc":"Look up many ids at once, raise NotFound if any of them are not found","ref":"Pointers.Tables.html#ids!/1","title":"Pointers.Tables.ids!/1","type":"function"},{"doc":"Look up a schema module by id, name or schema","ref":"Pointers.Tables.html#schema/1","title":"Pointers.Tables.schema/1","type":"function"},{"doc":"Look up a schema module by id, name or schema, raise NotFound if not found","ref":"Pointers.Tables.html#schema!/1","title":"Pointers.Tables.schema!/1","type":"function"},{"doc":"Populates the global cache with table data via introspection.","ref":"Pointers.Tables.html#start_link/1","title":"Pointers.Tables.start_link/1","type":"function"},{"doc":"Get a Table identified by name, id or module.","ref":"Pointers.Tables.html#table/1","title":"Pointers.Tables.table/1","type":"function"},{"doc":"Look up a Table by name or id, raise NotFound if not found.","ref":"Pointers.Tables.html#table!/1","title":"Pointers.Tables.table!/1","type":"function"},{"doc":"A query is either a table's (database) name or (Pointer) ID as a binary or the name of its Ecto Schema Module as an atom.","ref":"Pointers.Tables.html#t:query/0","title":"Pointers.Tables.query/0","type":"type"},{"doc":"We could not find the requested object","ref":"Pointers.NotFound.html","title":"Pointers.NotFound","type":"exception"},{"doc":"Creates a new NotFound","ref":"Pointers.NotFound.html#new/0","title":"Pointers.NotFound.new/0","type":"function"},{"doc":"","ref":"Pointers.NotFound.html#t:t/0","title":"Pointers.NotFound.t/0","type":"type"},{"doc":"hexdocspointersEcto's missing universal foreign keyOne foreign key to rule them all and in the darkness, bind them.-- Gandalf, paraphrased.A means of foreign keying many tables in one field. Designed for highly interlinked data in highly dynamic schemata where tracking all the foreign keys is neither desired nor practical.Note: a universal foreign key is actually a hard problem. Many approaches are on offer with a variety of tradeoffs. You should carefully consider a variety of approaches rather than just blindly adopting the one that fitted our project's needs the best!","ref":"readme.html","title":"pointers","type":"extras"},{"doc":"A Table is a record of a table that may be linked to by a pointer. A Pointer is a pointer id and a table id.With these two ingredients, we can construct a means of pointing to any table that has a Table entry.Pointer and Table IDs are both Pointers.ULID, a UUID-like type that combines a millisecond-precision timestamp and some randomness to reduce the likelihood of a clash. It naturally sorts both in binary and text form by time and as far as postgres is concerned, it's a UUID.","ref":"readme.html#background","title":"pointers - Background","type":"extras"},{"doc":"Aside from the hex dependency, you will also need to write a simple migration to set up the database before you can start writing your regular migrations:defmodule MyApp.Repo.Migrations.InitPointers do use Ecto.Migration import Pointers.Migration def up(), do: inits(:up) def down(), do: inits(:down) defp inits(dir) do init_pointers_ulid_extra(dir) # this one is optional but recommended init_pointers(dir) # this one is not optional end end","ref":"readme.html#installation","title":"pointers - Installation","type":"extras"},{"doc":"Pointable tables require a unique sentinel ULID to identify them. These must be 26 characters long and in the alphabet of Crockford's Base32. They should be easy to identify in a printout and might be silly.There is a helper function, synthesise!/1 in Pointers.ULID to assist with this process - give it a 26-character long binary of ascii alphanumerics and it will give you the closest ULID that matches back.Let's look at a simple schema:defmodule MyApp.Greeting do use Pointers.Pointable, otp_app: :my_app, source: &quot;myapp_greeting&quot;, table_id: &quot;GREET1NGSFR0MD0CEXAMP1E000&quot; pointable_schema do field :greeting, :string end endTo declare a pointable schema, we start by using Pointers.Pointable, providing the name of our otp application, the source table's name in the database and our chosen sentinel ULID.We then call pointable_schema and define any fields we wish to put directly in the table. For the most part, pointable_schema is like Ecto's schema macro, except you do not provide the table name and let it handle the primary key.If for some reason you wished to turn autogeneration off, you could pass autogenerate: false to the options provided when using Pointers.Pointable.Now let's define the migration for our schema:defmodule MyApp.Repo.Migrations.Greeting do use Ecto.Migration import Pointers.Migration def up() do create_pointable_table(:greeting, &quot;GREET1NGSFR0MD0CEXAMP1E000&quot;) do add :greeting, :text, null: false end end def down() do drop_pointable_table(:greeting, &quot;GREET1NGSFR0MD0CEXAMP1E000&quot;) end endAs you can see, it's pretty similar to defining a regular migration, except you use create_pointable_table and drop_pointable_table. Notice that our sentinel ULID makes an appearance again here. It's very important that these match what we declared in the schema.","ref":"readme.html#defining-a-pointable-type","title":"pointers - Defining a Pointable Type","type":"extras"},{"doc":"Ecto does not know anything about our scheme, so unless we specifically want something to reference one of the pointed tables, we typically belongs_to with Pointers.Pointer. The table in which we do this does not itself need to be pointable.defmodule MyApp.Foo do use Ecto.Schema alias Pointers.Pointer # regular ecto table, not pointable! schema &quot;hello&quot; do belongs_to :pointer, Pointer # who knows what it points to? end endYou may choose to reference a specific schema rather than Pointer if it will only point to a single table. If you do this, you must ensure that the referenced record exists in that table in the normal way. There may be some performance benefit, we didn't benchmark it.The migration is slightly more complex, we have to decide what type of a pointer it is. Pointers come in three categories:A strong pointer is not nullable and is deleted when the object it points to is deleted.A weak pointer is nullable and is nilified when the object it points to is deleted.An unbreakable pointer will raise when you attempt to delete the object it points to.TypeNullable?On DeleteStrongNoCascadeWeakYesSet NullUnbreakableNoRaiseIn this case we will use a strong pointer, because we want it to be deleted if the pointed object is deleted.defmodule MyApp.Repo.Migrations.Hello do use Ecto.Migration import Pointers.Migration def change() do create_if_not_exists table(:hello) do add :pointer, strong_pointer(), null: false add :greeting, :text, null: false end end endIf you are pointing to a specific table instead of pointer, strong_pointer/1 allows you to pass the name of that module (strong_pointer/0 calls this with Pointers.Pointer).","ref":"readme.html#referencing-pointers","title":"pointers - Referencing Pointers","type":"extras"},{"doc":"It is common that even though you have a universal foreign key, you will want to issue different queries based upon the type that is being pointed to. For this reason, it is up to you to decide how to perform an onward query.Pointers.schema/1 turns a Pointer into an Ecto schema module name you can switch against. Pointers.plan breaks down a list of Pointers into a map of ids keyed by schema module. It is handy to define some functions in your (non-library) application that can load any type of pointer in given contexts.","ref":"readme.html#dereferencing-pointers","title":"pointers - Dereferencing Pointers","type":"extras"},{"doc":"Since Pointer has a table, you can use its table_id field to filter by pointed type. Pointers.Tables.id!/1 (or ids!/1 for a list) can be used to obtain the IDs for a table or tables.Then you run into another problem, that even though you know all of the tables you're working with will have a certain field, you need to know which table they are to work with them! The solution to this is what we are calling 'mixin tables' for convenience.A mixin table has a Pointer primary key along with any other fields you wish to store in this mixin. By moving fields out to mixin tables, you gain knowledge of the table name to which you need to join.An example mixin schema:defmodule My.Creator use Pointers.Mixin, otp_app: :my_app, source: &quot;creator&quot; mixin_schema do belongs_to :creator, My.User end endMixin tables are not themselves pointable, so there is no need to specify a table id as when defining a pointable schema.The migration for this is slightly more complicated:defmodule My.Creator.Migration do import Ecto.Migration import Pointers.Migration defp creator_table(), do: My.Creator.__schema__(:source) defp user_table(), do: My.User.__schema__(:source) def migrate_creator(index_opts \\\\ []), do: migrate_creator(index_opts, direction()) defp migrate_creator(index_opts, :up) do create_mixin_table(creator_table()) do add :creator_id, strong_pointer(user_table()), null: false end create_if_not_exists(unique_index(creator_table(), [:creator_id], index_opts)) end defp migrate_creator(index_opts, :down) do drop_if_exists(unique_index(creator_table(), [:creator_id], index_opts)) drop_mixin_table(creator_table()) end end","ref":"readme.html#querying-pointers","title":"pointers - Querying Pointers","type":"extras"},{"doc":"The practical result of pointers is that it pushes a certain amount of validation and consistency logic back into elixir land. It is therefore your elixir code's responsibility to ensure that data is inserted into the appropriate mixin tables when inserting a pointable object and to manage deletions as appropriate.When assembling queries with mixin tables, pay careful attention to the type of join you are performing. An inner join is explicitly asking not to be shown objects that do not have a record for that mixin. You quite possibly wanted to left join.","ref":"readme.html#elixir-based-logic","title":"pointers - Elixir-based logic","type":"extras"},{"doc":"Every pointable or mixin schema is overrideable with configuration during compilation (this is why using them requires an :otp_app to be specified). For example, we could override Pointers.Table (which is a pointable table) thus:config :pointers, Pointers.Table, source: &quot;my_pointers_table&quot;The table_id is also configurable, but we don't recommend you change it.In addition, all pointable and mixin schemas permit extension with Flexto. See the Flexto docs for more information about how to extend schemas via configuration. You will probably at the very least want to insert some has_one for mixins off your pointables.","ref":"readme.html#configuration-and-overrides","title":"pointers - Configuration and overrides","type":"extras"},{"doc":"All solutions to the universal foreign key problem have tradeofs. Here are what we see as the deficiencies in our approach:It forces a ULID on you. This is great for us, but not everyone. ULID exposes a timestamp with millisecond precision. If the time of creation of a resource is sensitive information for your purposes, ULIDs are not going to be suitable for you.Ecto has no knowledge of the specialty of Pointer, e.g. Repo.preload does not work and you need to specify a join condition to join through a pointer. Use our functions.Dereferencing a list of pointers requires a select query per table type that occurs in the input set.Reliance on user attention. You have to follow the instructions correctly to make the system work at all.There is likely some performance impact from postgres not understanding the relationships between the various tables properly. It's hard to gauge and we haven't even tried.These are not likely to change. If you're going to pick this library, do so in the full knowledge of the tradeoffs it makes.Alternatives include (I'm sure you can think of others):Storing the table name in a second column alongside every foreign key.A compound datatype of id and table name.Byte/String manipulation tricks.Evil SQL hacks based upon compile time configuration.While we have our gripes with this approach, once you've gotten the hang of using it, it works out pretty well for most purposes and it's one of the simpler options to work with.","ref":"readme.html#tradeoffs","title":"pointers - Tradeoffs","type":"extras"},{"doc":"Docs!Tests!mix pointers.gen.migration.init task to generate an init migration.mix pointers.gen.schema.pointable task to generate a pointable schema.mix pointers.gen.schema.mixin task to generate a mixin schema.","ref":"readme.html#todo","title":"pointers - TODO","type":"extras"},{"doc":"Copyright (c) 2020 pointers ContributorsLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"pointers - Copyright and License","type":"extras"}]